/*
 * @(#)pLine2D.java    Dec 31, 1997
 * 
 * Copyright (c) 1997, Particle
 * 
 * Sale of this "Software" is prohibited!  Only FREE
 * distribution is alowed.
 *
 * -- Particle --
 */

import pPoint2D;
import pPlane2D;

/**
 * A <code>pLine2D</code> class is a very basic 2D Line.
 * <p>
 * It alows users to set and get values of a 2D Line.
 *
 * @version     1.0 12/31/1997
 * @author      Particle
 */

public class pLine2D{
	
        /**
         * A 2 element array of <code>pPoint2D</code> objects,
         * representing the 'start' and 'end' of the line.
         *
         * @see pPoint2D
         */
        public pPoint2D [] v = null;

        /**
         * Constructs a <code>pLine2D</code> object.
         * @see pPoint2D
         */
        public pLine2D(){
                v = new pPoint2D[2];
                setStart(new pPoint2D());
                setEnd(new pPoint2D());
        }

        /**
         * Constructs a <code>pLine2D</code> object from
         * a pLine2D object, (basically a copy constructor).
         * @see pPoint2D
         * @param l the pLine2d of which to make a copy of.
         */
        public pLine2D(pLine2D l){
                v = new pPoint2D[2];
                setStart(new pPoint2D(l.getStart()));
                setEnd(new pPoint2D(l.getEnd()));
        }
			
	
	  /**
         * Constructs a <code>pLine2D</code> object from
         * 2 pPoint2D objects. (the start <code>pPoint2D</code>
         * and an end <code>pPoint2D</code>
         * @param a the start of the line
         * @param b the end of the line
         */
        public pLine2D(pPoint2D a,pPoint2D b){
                v = new pPoint2D[2];
                setStart(new pPoint2D(a));
                setEnd(new pPoint2D(b));
        }
	
		
		/**
		 * Gets the starting point of the line
		 * 
		 * @return the starting point.
		 */
		public pPoint2D getStart(){
			return v[0];
		}

		/** 
		 * Gets the endint point of the line
		 * 
		 * @return the ending point.
		 */
		public pPoint2D getEnd(){
			return v[1];
		}

		/**
		 * Sets the start of the line
		 * 
		 * @param s the starting point.
		 */
		public void setStart(pPoint2D s){
			v[0] = new pPoint2D(s);
		}

		/**
		 * Sets the ending point of the line
		 * 
		 * @param e the ending point of the line
		 */
		public void setEnd(pPoint2D e){
			v[1] = new pPoint2D(e);
		}

		/**
		 * Gets the "plane" which this line is part of.  Basically
		 * gets those "plane" methods for determining whether some
		 * point (or line) is in front of behind it, and an ability 
		 * to split lines.
		 *
		 * @return the plane for that line
		 */	
        public pPlane2D getPlane(){
                return new pPlane2D(this);
        }

		/**
		 * standard <code>toString()</code> method.
		 *
		 * @return the string representing that object.
		 */
        public String toString(){
                return new String("pLine2D("+getStart()+","+getEnd()+");\n");
        }
}

