/*
 * @(#)pNode.java    Dec 31, 1997
 * 
 * Copyright (c) 1997, Particle
 * 
 * Sale of this "Software" is prohibited!  Only FREE
 * distribution is alowed.
 *
 * -- Particle --
 */

import java.lang.Object;

/**
 * A <code>pNode</code> class is a very basic Node.
 * <p>
 * It alows users to set and get values of a Node.
 *
 * @version     1.0 12/31/1997
 * @author      Particle
 */

public class pNode{
	
	/**
	 * the data
	 */	
	protected Object data;

	/** 
	 * a "pointer" to the next node 
	 */
	protected pNode next;

	/**
	 * Creates a new pNode object.  (basically sets the internals to null
	 */
	public pNode(){
      	next = null;
		data = null;
	}
	
	/**
	 * Creates a pNode object, given data and a pointer to the next node.
	 */
    	public pNode(Object data,pNode next){
      	this.data = data;
        	this.next = next;
   	}

	/**
	 * sets the "next" node... 
	 *
	 * @param next the next node in the list
	 */
    	public void setnext(pNode next){
      	this.next = next;
    	}

	/**
	 * sets the data field of the node.
	 *
	 * @param data the data of object type, thus, any object can be used
	 */
  	public void setdata(Object data){
     		this.data = data;
   	}

	/**
	 * gets the next node in the "list" ...
	 *
	 * @return the "next" node.
	 */
  	public pNode getnext(){
      	return next;
   	}

	/**
	 * gets the data field of the node.
	 * 
	 * @return the data of type Object, most times, a cast is needed.
	 * @see Object
	 */
    	public Object getdata(){
      	return data;
    	}	
	
	/** 
	 * a standard <code>toString</code> method
	 */
	public String toString(){
      	return new String((String)data);	
	}
}
