/*
 * @(#)pPoint2D.java    Dec 30, 1997
 * 
 * Copyright (c) 1997, Particle
 * 
 * Sale of this "Software" is prohibited!  Only FREE
 * distribution is alowed.
 *
 * -- Particle --
 */


/**
 * A <code>pPoint2D</code> class is a very basic 2D point.
 * <p>
 * It alows users to set and get values of a 2D point.
 *
 * @version     1.0 12/30/1997
 * @author      Particle
 */

public class pPoint2D{
        /**
         * A 2 element array, representing the X
         * and Y coordinates.
         */
        public double [] v = null;

        /** 
         * Constructs a new pPoint2D.
         */
        public pPoint2D(){
                v = new double[2];
        }

        /**
         * Constructs a new <code>pPoint2D</code> object.
         * <p>
         * @param       x       The X coordinate value
         * @param       y       The Y coordinate value
         */
        public pPoint2D(double x,double y){
                v = new double[2];
                setx(x);
                sety(y);
        }

        /**
         * Constructs a new <code>pPoint2D</code> object.
         * <p>
         * @param       p       A pPoint2D of which to make a copy
         */
        public pPoint2D(pPoint2D p){
                v = new double[2];
                setx(p.getx());
                sety(p.gety());
        }

        /**
         * Gets X value of the point.
         * @return      An X value of the point.
         */
        public double getx(){
                return v[0];
        }

        /**
         * Get Y value of the point.
         * @return      A Y value of the point.
         */
        public double gety(){
                return v[1];
        }

        /**
         * Sets X value of the point.
         * @param       x       An X coordinate value of the point.
         */
        public void setx(double x){
                v[0] = x;
        }

        /**
         * Sets Y value of the point.
         * @param       y       A Y coordinate value of the point.
         */
        public void sety(double y){
                v[1] = y;
        }

        /**
         * The <code>toString</code> method.
         * @return a <code>String</code> represending
         * the <code>pPoint2D</code>
         */
        public String toString(){
                return new String("("+getx()+","+gety()+")");
        }
}
